<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ettevõtted</title>
    <style>
        * {
            font-family: Calibri;
        }
    </style>
</head>

<body>
    <h1>Ettevõtted</h1>

    <div id="companiesList"></div>

    <div style="border: 3px solid dodgerblue; padding: 10px; margin: 10px">
        <h2>Ettevõtte lisamine</h2>
        Nimi: <br>
        <input type="text" id="companyName"> <br>
        Töötajaid: <br>
        <input type="number" id="companyEmployees"> <br>
        Asutatud: <br>
        <input type="date" id="companyEstablished"> <br><br>
        <button onclick="addCompany()">Lisa</button>
    </div>

    <script>

        // Klassikaline Promisite manageerimine

        // console.log('Hakkame tegema päringut');
        // let response = fetch('https://frogaccelerator.com:8110/companies');

        // // Kui response promise resolvitakse, käititatakse see funktsioon siin.
        // // Sisendparameetriks on promise tulemus.
        // response.then(result => result.json()).then(companies => {
        //     console.log('Ettevõtted Mareki serverist', companies);
        // }).catch(error => console.log('Midagi lendas õhku!', error));

        // console.log('Päring teele saadetud');

        // Uus lähenemine: ootame Promisi järel kuniks ta oma töö ära teeb

        // async - minu funktsioon kolib koos Promisiga "teispoolsusesse".
        async function fetchCompanies() {
            try {
                let response = await fetch('https://frogaccelerator.com:8110/companies');
                let companies = await response.json();
                console.log('Ettevõtted Mareki serverist', companies);
                console.log('Päring teostatud, tulemus käes!');
                displayCompanies(companies);
            } catch (e) {
                // Kui mu Promise õhku lendab, saan siin probleemi hallata.
                console.log('Mingi jama!', e);
            }
        }

        async function fetchSingleCompany(companyId) {
            try {
                let response = await fetch(`https://frogaccelerator.com:8110/companies/${companyId}`);
                let company = await response.json();
                console.log('ETTEVÕTE:');
                console.log(company);
            } catch (e) {
                console.log('Mingi jama!', e);
            }
        }

        console.log('Hakkame tegema päringut!');
        fetchCompanies();

        fetchSingleCompany(34);
        console.log('Ettevõtete pärimise funktsioon käivitus!');

        async function addCompany() {
            const company = {
                name: document.querySelector('#companyName').value,
                employees: document.querySelector('#companyEmployees').value,
                established: document.querySelector('#companyEstablished').value
            }
            try {
                const response = await fetch('https://frogaccelerator.com:8110/companies', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    body: JSON.stringify(company)
                });
                await fetchCompanies();
            } catch (e) {
                console.log('Salvestamine ebaõnnestus!', e);
            }
        }

        async function deleteCompany(companyId) {
            try {
                const response = await fetch(`https://frogaccelerator.com:8110/companies/${companyId}`, {
                    method: 'DELETE'
                });
            } catch (e) {
                console.log(`Ettevõtte ${companyId} kustutamine ebaõnnestus`, e);
            }
        }

        function displayCompanies(companies) {
            const companiesDiv = document.querySelector('#companiesList');

            let companiesHtml = '';

            for (let i = 0; i < companies.length; i++) {
                companiesHtml += /*html*/`
                    <div style="border: 1px solid lightskyblue; border-radius: 5px; margin: 5px; padding: 10px;">
                    <h3 style="color: blue">${companies[i].name}</h3>
                    <p>Asutatud: ${companies[i].established}</p>
                    <p>Töötajaid: <strong>${companies[i].employees}</strong></p>
                    </div>
                `;
            }

            companiesDiv.innerHTML = companiesHtml;
        }

    </script>
</body>

</html>